# Hydrology, weirs and open flow (fluids.open_flow)

`fluids.open_flow.``Q_weir_V_Shen`(h1, angle=90)

  Calculates the flow rate across a V-notch (triangular) weir from the height of the liquid above the tip of the notch, and with the angle of the notch. Most of these type of weir are 90 degrees. Model from [R526] as reproduced in [R527].

  Flow rate is given by:

  \[Q = C \tan\left(\frac{\theta}{2}\right)\sqrt{g}(h_1 + k)^{2.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the notch [m]

  angle : float, optional

  > Angle of the notch [degrees]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  angles = [20, 40, 60, 80, 100] Cs = [0.59, 0.58, 0.575, 0.575, 0.58] k = [0.0028, 0.0017, 0.0012, 0.001, 0.001]

  The following limits apply to the use of this equation:

  h1 >= 0.05 m h2 > 0.45 m h1/h2 <= 0.4 m b > 0.9 m

  \[\frac{h_1}{b}\tan\left(\frac{\theta}{2}\right) < 2\]

  Flows are lower than obtained by the curves at http://www.lmnoeng.com/Weirs/vweir.php.

  References

  [R526] | (1, 2) Shen, John. “Discharge Characteristics of Triangular-Notch Thin-Plate Weirs : Studies of Flow to Water over Weirs and Dams.” USGS Numbered Series. Water Supply Paper. U.S. Geological Survey : U.S. G.P.O., 1981

  [R527] | (1, 2) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  Examples

      >>> Q_weir_V_Shen(0.6, angle=45)
      0.21071725775478228

`fluids.open_flow.``Q_weir_rectangular_Kindsvater_Carter`(h1, h2, b)

  Calculates the flow rate across rectangular weir from the height of the liquid above the crest of the notch, the liquid depth beneath it, and the width of the notch. Model from [R528] as reproduced in [R529].

  Flow rate is given by:

  \[Q = 0.554\left(1 - 0.0035\frac{h_1}{h_2}\right)(b + 0.0025) \sqrt{g}(h_1 + 0.0001)^{1.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the crest of the weir [m]

  h2 : float

  > Height of the fluid below the crest of the weir [m]

  b : float

  > Width of the rectangular flow section of the weir [m]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  The following limits apply to the use of this equation:

  b/b1 ≤ 0.2 h1/h2 < 2 b > 0.15 m h1 > 0.03 m h2 > 0.1 m

  References

  [R528] | (1, 2) Kindsvater, Carl E., and Rolland W. Carter. “Discharge Characteristics of Rectangular Thin-Plate Weirs.” Journal of the Hydraulics Division 83, no. 6 (December 1957): 1-36.

  [R529] | (1, 2) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  Examples

      >>> Q_weir_rectangular_Kindsvater_Carter(0.2, 0.5, 1)
      0.15545928949179422

`fluids.open_flow.``Q_weir_rectangular_SIA`(h1, h2, b, b1)

  Calculates the flow rate across rectangular weir from the height of the liquid above the crest of the notch, the liquid depth beneath it, and the width of the notch. Model from [R530] as reproduced in [R531].

  Flow rate is given by:

  \[Q = 0.544\left[1 + 0.064\left(\frac{b}{b_1}\right)^2 + \frac{0.00626 - 0.00519(b/b_1)^2}{h_1 + 0.0016}\right] \left[1 + 0.5\left(\frac{b}{b_1}\right)^4\left(\frac{h_1}{h_1+h_2} \right)^2\right]b\sqrt{g}h^{1.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the crest of the weir [m]

  h2 : float

  > Height of the fluid below the crest of the weir [m]

  b : float

  > Width of the rectangular flow section of the weir [m]

  b1 : float

  > Width of the full section of the channel [m]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  The following limits apply to the use of this equation:

  b/b1 ≤ 0.2 h1/h2 < 2 b > 0.15 m h1 > 0.03 m h2 > 0.1 m

  References

  [R530] | (1, 2) Normen für Wassermessungen: bei Durchführung von Abnahmeversuchen an Wasserkraftmaschinen. SIA, 1924.

  [R531] | (1, 2) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  Examples

      >>> Q_weir_rectangular_SIA(0.2, 0.5, 1, 2)
      1.0408858453811165

`fluids.open_flow.``Q_weir_rectangular_full_Ackers`(h1, h2, b)

  Calculates the flow rate across a full-channel rectangular weir from the height of the liquid above the crest of the weir, the liquid depth beneath it, and the width of the channel. Model from [R532] as reproduced in [R533], confirmed with [R534].

  Flow rate is given by:

  \[Q = 0.564\left(1+0.150\frac{h_1}{h_2}\right)b\sqrt{g}(h_1+0.001)^{1.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the crest of the weir [m]

  h2 : float

  > Height of the fluid below the crest of the weir [m]

  b : float

  > Width of the channel section [m]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  The following limits apply to the use of this equation:

  h1 > 0.02 m h2 > 0.15 m h1/h2 ≤ 2.2

  References

  [R532] | (1, 2) Ackers, Peter, W. R. White, J. A. Perkins, and A. J. M. Harrison. Weirs and Flumes for Flow Measurement. Chichester ; New York: John Wiley & Sons Ltd, 1978.

  [R533] | (1, 2) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  [R534] | (1, 2, 3) Cengel, Yunus, and John Cimbala. Fluid Mechanics: Fundamentals and Applications. Boston: McGraw Hill Higher Education, 2006.

  Examples

  Example as in [R534], matches. However, example is unlikely in practice.

      >>> Q_weir_rectangular_full_Ackers(h1=0.9, h2=0.6, b=5)
      9.251938159899948

`fluids.open_flow.``Q_weir_rectangular_full_SIA`(h1, h2, b)

  Calculates the flow rate across a full-channel rectangular weir from the height of the liquid above the crest of the weir, the liquid depth beneath it, and the width of the channel. Model from [R535] as reproduced in [R536].

  Flow rate is given by:

  \[Q = \frac{2}{3}\sqrt{2}\left(0.615 + \frac{0.000615}{h_1+0.0016}\right) b\sqrt{g} h_1 +0.5\left(\frac{h_1}{h_1+h_2}\right)^2b\sqrt{g} h_1^{1.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the crest of the weir [m]

  h2 : float

  > Height of the fluid below the crest of the weir [m]

  b : float

  > Width of the channel section [m]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  The following limits apply to the use of this equation:

  0.025 < h < 0.8 m b > 0.3 m h2 > 0.3 m h1/h2 < 1

  References

  [R535] | (1, 2) Normen für Wassermessungen: bei Durchführung von Abnahmeversuchen an Wasserkraftmaschinen. SIA, 1924.

  [R536] | (1, 2, 3) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  Examples

  Example compares terribly with the Ackers expression - probable error in [R536]. DO NOT USE.

      >>> Q_weir_rectangular_full_SIA(h1=0.3, h2=0.4, b=2)
      1.1875825055400384

`fluids.open_flow.``Q_weir_rectangular_full_Rehbock`(h1, h2, b)

  Calculates the flow rate across a full-channel rectangular weir from the height of the liquid above the crest of the weir, the liquid depth beneath it, and the width of the channel. Model from [R538] as reproduced in [R539].

  Flow rate is given by:

  \[Q = \frac{2}{3}\sqrt{2}\left(0.602 + 0.0832\frac{h_1}{h_2}\right) b\sqrt{g} (h_1 +0.00125)^{1.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the crest of the weir [m]

  h2 : float

  > Height of the fluid below the crest of the weir [m]

  b : float

  > Width of the channel section [m]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  The following limits apply to the use of this equation:

  0.03 m < h1 < 0.75 m b > 0.3 m h2 > 0.3 m h1/h2 < 1

  References

  [R538] | (1, 2) King, H. W., Floyd A. Nagler, A. Streiff, R. L. Parshall, W. S. Pardoe, R. E. Ballester, Gardner S. Williams, Th Rehbock, Erik G. W. Lindquist, and Clemens Herschel. “Discussion of ‘Precise Weir Measurements.’” Transactions of the American Society of Civil Engineers 93, no. 1 (January 1929): 1111-78.

  [R539] | (1, 2) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  Examples

      >>> Q_weir_rectangular_full_Rehbock(h1=0.3, h2=0.4, b=2)
      0.6486856330601333

`fluids.open_flow.``Q_weir_rectangular_full_Kindsvater_Carter`(h1, h2, b)

  Calculates the flow rate across a full-channel rectangular weir from the height of the liquid above the crest of the weir, the liquid depth beneath it, and the width of the channel. Model from [R540] as reproduced in [R541].

  Flow rate is given by:

  \[Q = \frac{2}{3}\sqrt{2}\left(0.602 + 0.0832\frac{h_1}{h_2}\right) b\sqrt{g} (h_1 +0.00125)^{1.5}\]

  Parameters:

  h1 : float

  > Height of the fluid above the crest of the weir [m]

  h2 : float

  > Height of the fluid below the crest of the weir [m]

  b : float

  > Width of the channel section [m]

  Returns:

  Q : float

  > Volumetric flow rate across the weir [m^3/s]

  Notes

  The following limits apply to the use of this equation:

  h1 > 0.03 m b > 0.15 m h2 > 0.1 m h1/h2 < 2

  References

  [R540] | (1, 2) Kindsvater, Carl E., and Rolland W. Carter. “Discharge Characteristics of Rectangular Thin-Plate Weirs.” Journal of the Hydraulics Division 83, no. 6 (December 1957): 1-36.

  [R541] | (1, 2) Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  Examples

      >>> Q_weir_rectangular_full_Kindsvater_Carter(h1=0.3, h2=0.4, b=2)
      0.641560300081563

`fluids.open_flow.``V_Manning`(Rh, S, n)

  Predicts the average velocity of a flow across an open channel of hydraulic radius Rh and slope S, given the Manning roughness coefficient n.

  Flow rate is given by:

  \[V = \frac{1}{n} R_h^{2/3} S^{0.5}\]

  Parameters:

  Rh : float

  > Hydraulic radius of the channel, Flow Area/Wetted perimeter [m]

  S : float

  > Slope of the channel, m/m [-]

  n : float

  > Manning roughness coefficient [s/m^(1/3)]

  Returns:

  V : float

  > Average velocity of the channel [m/s]

  Notes

  This is equation is often given in imperial units multiplied by 1.49.

  References

  [R542] | Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  [R543] | (1, 2) Cengel, Yunus, and John Cimbala. Fluid Mechanics: Fundamentals and Applications. Boston: McGraw Hill Higher Education, 2006.

  Examples

  Example is from [R543], matches.

      >>> V_Manning(0.2859, 0.005236, 0.03)
      1.0467781958118971

`fluids.open_flow.``n_Manning_to_C_Chezy`(n, Rh)

  Converts a Manning roughness coefficient to a Chezy coefficient, given the hydraulic radius of the channel.

  \[C = \frac{1}{n}R_h^{1/6}\]

  Parameters:

  n : float

  > Manning roughness coefficient [s/m^(1/3)]

  Rh : float

  > Hydraulic radius of the channel, Flow Area/Wetted perimeter [m]

  Returns:

  C : float

  > Chezy coefficient [m^0.5/s]

  References

  [R544] | Chow, Ven Te. Open-Channel Hydraulics. New York: McGraw-Hill, 1959.

  Examples

  Custom example, checked.

      >>> n_Manning_to_C_Chezy(0.05, Rh=5)
      26.15320972023661

`fluids.open_flow.``C_Chezy_to_n_Manning`(C, Rh)

  Converts a Chezy coefficient to a Manning roughness coefficient, given the hydraulic radius of the channel.

  \[n = \frac{1}{C}R_h^{1/6}\]

  Parameters:

  C : float

  > Chezy coefficient [m^0.5/s]

  Rh : float

  > Hydraulic radius of the channel, Flow Area/Wetted perimeter [m]

  Returns:

  n : float

  > Manning roughness coefficient [s/m^(1/3)]

  References

  [R545] | Chow, Ven Te. Open-Channel Hydraulics. New York: McGraw-Hill, 1959.

  Examples

  Custom example, checked.

      >>> C_Chezy_to_n_Manning(26.15, Rh=5)
      0.05000613713238358

`fluids.open_flow.``V_Chezy`(Rh, S, C)

  Predicts the average velocity of a flow across an open channel of hydraulic radius Rh and slope S, given the Chezy coefficient C.

  Flow rate is given by:

  \[V = C\sqrt{S R_h}\]

  Parameters:

  Rh : float

  > Hydraulic radius of the channel, Flow Area/Wetted perimeter [m]

  S : float

  > Slope of the channel, m/m [-]

  C : float

  > Chezy coefficient [m^0.5/s]

  Returns:

  V : float

  > Average velocity of the channel [m/s]

  References

  [R546] | Blevins, Robert D. Applied Fluid Dynamics Handbook. New York, N.Y.: Van Nostrand Reinhold Co., 1984.

  [R547] | Cengel, Yunus, and John Cimbala. Fluid Mechanics: Fundamentals and Applications. Boston: McGraw Hill Higher Education, 2006.

  [R548] | Chow, Ven Te. Open-Channel Hydraulics. New York: McGraw-Hill, 1959.

  Examples

  Custom example, checked.

      >>> V_Chezy(Rh=5, S=0.001, C=26.153)
      1.8492963648371776